
//Szukanie polowkowe (binarne)
//uwaga: elementy tablicy w C numerowane sa od 0
//       zatem nasza tablica ma indeksy od 0 do n-1
//       a[0], a[1], ..., a[n-1]
//(c) 2009 by Tomasz Lubinski
//www.algorytm.org

#include "stdio.h"

void main(void)
{
   int i, n, x, l, p, s;
   int a[100];
		
   //pobierz dane od uzytkownika
   printf("Podaj liczbe elementow tablicy (max. 100)\n");
   scanf("%d", &n);
   for (i=0; i<n; i++) 
   {
      printf("Podaj element a[%d]\n", i);
      scanf("%d", &a[i]);
   }
   printf("Podaj element do wyszukania\n");
   scanf("%d", &x);
	
   //szukaj elementu x
   l = 0;
   p = n - 1;
   while (l <= p) 
   {
      s = (l + p) / 2;
			
      if (a[s] == x) 
      {
         //podaj wynik
         printf("Odnaleziono element %d pod indeksem %d\n", x, s);
         //zakoncz program
         return;
      }

      if (a[s] < x)
         l = s + 1;
      else
         p = s - 1;		
   }
		  
   //podaj wynik
   printf("Nie odnaleziono w tablicy elementu %d\n", x);
}
